#include "../main/bootpack.h"
#include "../main/ide.h"
#include <stdio.h>
#include <string.h>

#define	VAR_WALL		0x00
#define	VAR_OSNAME		0x01

extern char cpath[256];
extern char epath[1024];
void dir_cons(struct CONSOLE *cons, struct FILEINFO *finfo);
int Openfile(struct CONSOLE *cons, char *filename, int *fat);

extern unsigned short table_8_565[256];

void cons_runcmd(char *cmdline, struct CONSOLE *cons, int *fat, int memtotal)
{
	if (strcmp(cmdline, "mem") == 0 && cons->sht != 0) {
		cmd_mem(cons, memtotal);

	} else if (strcmp(cmdline, "cls") == 0 && cons->sht != 0) {
		cmd_cls(cons);

	} else if (strcmp(cmdline, "clear") == 0 && cons->sht != 0) {
		cmd_cls(cons);

	} else if (strcmp(cmdline, "clean") == 0 && cons->sht != 0) {
		cmd_cls(cons);

	} else if (strcmp(cmdline, "dir") == 0 && cons->sht != 0) {
		cmd_dir(cons, fat);

	} else if (strcmp(cmdline, "dircd") == 0 && cons->sht != 0) {
		cmd_dir_cd(cons);

	} else if (strcmp(cmdline, "ls") == 0 && cons->sht != 0) {
		cmd_dir(cons, fat);

	} else if (strcmp(cmdline, "exit") == 0) {
		cmd_exit(cons, fat);

	} else if (strcmp(cmdline, "quit") == 0) {
		cmd_exit(cons, fat);

	} else if (strcmp(cmdline, "q") == 0) {
		cmd_exit(cons, fat);

	} else if (strncmp(cmdline, "rem", 3) == 0) {
		/* ɂȂ */

	} else if (strncmp(cmdline, "nop", 3) == 0) {
		/* ɂȂ */

	} else if (strcmp(cmdline, OS_NAMEL) == 0) {
		cmd_isotope(cons);

	} else if (strcmp(cmdline, "bootdevmode") == 0) {
		cmd_bootdevmode(cons);

	} else if (strcmp(cmdline, "reset") == 0) {
		cmd_reset(cons);

	} else if (strcmp(cmdline, "ver") == 0) {
		cmd_isotope(cons);

	} else if (strcmp(cmdline, "time") == 0) {
		cmd_time(cons);

	} else if (strcmp(cmdline, "shutdown") == 0) {
		cmd_shutdown(cons);

	} else if (strncmp(cmdline, "cd2copy ", 8) == 0) {
		cmd_cd_start(cons, cmdline, fat);

	} else if (strncmp(cmdline, "start ", 6) == 0) {
		cmd_start(cons, cmdline, memtotal);

	} else if (strncmp(cmdline, "ncst ", 5) == 0) {
		cmd_ncst(cons, cmdline, memtotal);
		
	} else if (strncmp(cmdline, "cd ", 3) == 0) {
		cmd_cd(cons, cmdline, fat);

	} else if (strncmp(cmdline, "del ", 4) == 0) {
		cmd_del(cons, cmdline, fat);

	} else if (strncmp(cmdline, "langmode ", 9) == 0) {
		cmd_langmode(cons, cmdline);
		
	} else if (strncmp(cmdline, "wall ", 5) == 0) {
		cmd_setvar(cons, cmdline, VAR_WALL);

	} else if (cmdline[0] != 0) {
		if (cmd_app(cons, fat, cmdline) == 0 && Openfile(cons, cmdline, fat) == 0) {
			/* R}hł͂ȂAAvłȂAɋsłȂ */
			cmd_notfound(cmdline, cons);
		}
	}
	return;
}

void cmd_mem(struct CONSOLE *cons, int memtotal)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	char s[60];
	sprintf(s, "total   %dMB\nfree %dKB\n\n", memtotal / (1024 * 1024), memman_total(memman) / 1024);
	cons_putstr0(cons, s);
	return;
}

void cmd_cls(struct CONSOLE *cons)
{
	int x, y;
	struct SHEET *sheet = cons->sht;
	for (y = 28; y < 28 + 128; y++) {
		for (x = 8; x < 8 + 240; x++) {
			sheet->buf[x + y * sheet->bxsize] = table_8_565[94];
		}
	}
	sheet_refresh(sheet, 8, 28, 8 + 240, 28 + 128);
	cons->cur_y = 28;
	return;
}

void cmd_dir(struct CONSOLE *cons, int *fat)
{
	int i, rde = 0;
	int clustno, nextno;
	struct FILEINFO *ffinfo, dfinfo[16];

	if (strcmp(cpath, "/") == 0) {
		ffinfo = (struct FILEINFO *) (ADR_DISKIMG + 0x002600);
		rde = 1;
	} else {
		ffinfo = file_search2(cpath, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224, fat);
		if (ffinfo == 0 || (ffinfo->type & 0x10) != 0x10) {
			return;
		}
		if (ffinfo->clustno == 0x0000) {
			rde = 1;
		}
	}

	if (rde == 1) {
		for (i = 0; i < 224; i++) {
			if (ffinfo[i].name[0] == 0x00) {
				break;
			}
			dir_cons(cons, &ffinfo[i]);
		}
	} else {
		nextno = ffinfo->clustno;
		for (i = 0; i < MAX_ENTRY; i++) {
			if ((i % 16) == 0) {
				if (nextno >= 0x0ff7) {
					break;
				}
				clustno = nextno;
				file_loadfile(clustno, 512, (char *) dfinfo,
							  fat, (char *) (ADR_DISKIMG + 0x003e00));
				nextno = fat[clustno];
			}
			if (dfinfo[i % 16].name[0] == 0x00) {
				break;
			}
			dir_cons(cons, &dfinfo[i % 16]);
		}
	}
	cons_newline(cons);

	return;
}

void cmd_cd(struct CONSOLE *cons, char *cmdline, int *fat)
{
	char fpath[256];
	struct FILEINFO *ffinfo;

	file_path(fpath, cmdline + 3, sizeof(fpath));
	if (fpath[0] == 0) {
		cons_putstr0(cons, "No such directory.\n\n");
		return;
	}

	if (strcmp(fpath, "/") == 0) {
		memset(cpath, 0, sizeof(cpath));
		cpath[0] = '/';
	} else {
		ffinfo = file_search2(fpath, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224, fat);
		if (ffinfo != 0 && (ffinfo->type & 0x10) == 0x10) {
			memset(cpath, 0, sizeof(cpath));
			strcpy(cpath, fpath);
			if (cpath[strlen(cpath) - 1] != '/') {
				cpath[strlen(cpath)] = '/';
			}
		} else {
			if (cons->sht != 0) {
				cons_putstr0(cons, "Couldn't find directory.\n\n");
			}
		}
	}

	return;
}

void cmd_del(struct CONSOLE *cons, char *cmdline, int *fat)
{
	if (hrb_api_remove(cmdline + 4, fat) == -1) {
		if (cons->sht != 0) {
			cons_putstr0(cons, "Couldn't find file.\n\n");
		}
	}
	return;
}

void cmd_exit(struct CONSOLE *cons, int *fat)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct TASK *task = task_now();
	struct SHTCTL *shtctl = (struct SHTCTL *) *((int *) 0x0fe4);
	struct FIFO32 *fifo = (struct FIFO32 *) *((int *) 0x0fec);
	if (cons->sht != 0) {
		timer_cancel(cons->timer);
	}
	memman_free_4k(memman, (int) fat, 4 * 2880);
	io_cli();
	if (cons->sht != 0) {
		fifo32_put(fifo, cons->sht - shtctl->sheets0 + 768);	/* 768`1023 */
	} else {
		fifo32_put(fifo, task - taskctl->tasks0 + 1024);	/* 1024`2023 */
	}
	io_sti();
	for (;;) {
		task_sleep(task);
	}
}

void cmd_start(struct CONSOLE *cons, char *cmdline, int memtotal)
{
	struct SHTCTL *shtctl = (struct SHTCTL *) *((int *) 0x0fe4);
	struct SHEET *sht = open_console(shtctl, memtotal);
	struct FIFO32 *fifo = &sht->task->fifo;
	int i;
	sheet_slide(sht, 32, 4);
	sheet_updown(sht, shtctl->top);
	/* R}hCɓ͂ꂽAꕶVR\[ɓ */
	for (i = 6; cmdline[i] != 0; i++) {
		fifo32_put(fifo, cmdline[i] + 256);
	}
	fifo32_put(fifo, 10 + 256);	/* Enter */
	cons_newline(cons);
	return;
}

void cmd_dir_cd(struct CONSOLE *cons)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	char s[60];
	int controller, deviceNo;
	PrimaryVolumeDescriptor* pvd;
	DirectoryEntry* root;
	dword size;
	dword position;
	byte* buffer;

	/*  */
	IDEDriver *driver = (IDEDriver *) memman_alloc_4k(memman, sizeof(IDEDriver));
	IDEDriver_IDEDriver(driver, IDE_IRQ_PRIMARY, IDE_IRQ_SECONDARY);

	/* ATAPI foCX̌ */
	if ( !IDEDriver_findDevice(driver, DEVICE_ATAPI, 0x05, &controller, &deviceNo) ) {
		return;
	}

	/* ATAPI foCX̎gpJn */
	if ( !IDEDriver_selectDevice(driver, controller, deviceNo) ) {
		return;
	}

	/* {{[Lqq̓ǂݍ */
	pvd = (PrimaryVolumeDescriptor*) memman_alloc_4k(memman, sizeof(PrimaryVolumeDescriptor));
	IDEDriver_read(driver, 16, pvd, SECTOR_SIZE); /* 16ZN^[܂ł̓u[g̈Ȃ̂ */
	if (pvd->type[0] != ISO_PRIMARY_VOLUME_DESCRIPTOR || strncmp("CD001", pvd->id, 5) != 0) {
		return;
	}

	/* [gfBNgǂݍ */
	root = (DirectoryEntry *)( pvd->root_directory_record );
	size = ((dword)((root->size_l + SECTOR_SIZE - 1) / SECTOR_SIZE)) * SECTOR_SIZE;
	buffer = (byte *) memman_alloc_4k(memman, size);
	IDEDriver_read(driver, root->extent_l, buffer, size);
	for (position = 0; position < size;) {
		DirectoryEntry* dir = (DirectoryEntry *) (buffer + position);
		if (dir->size_l == 0) {
			break;
		} else if (dir->directory == 0) {
			dir->name[dir->name_len - 2] = '\0';
			sprintf(s, "%8d  %s\n", dir->size_l, dir->name);
			cons_putstr0(cons, s);
		}
		position += dir->length;
	}
	memman_free_4k(memman, (int) buffer, size);
	cons_newline(cons);
	
	return;
}

void cmd_cd_start(struct CONSOLE *cons, char *cmdline, int *fat)
{
    /*  */
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
    IDEDriver* driver = (IDEDriver *) memman_alloc_4k(memman, sizeof(IDEDriver));
    IDEDriver_IDEDriver(driver, IDE_IRQ_PRIMARY, IDE_IRQ_SECONDARY);
	struct FILEHANDLE *fh = 0;

    /* ATAPI foCX̌ */
    int controller, deviceNo;
    if ( !IDEDriver_findDevice(driver, DEVICE_ATAPI, 0x05, &controller, &deviceNo) ) {
        return;
    }

    /* ATAPI foCX̎gpJn */
    if ( !IDEDriver_selectDevice(driver, controller, deviceNo) ) {
        return;
    }

    /* {{[Lqq̓ǂݍ */
    PrimaryVolumeDescriptor* pvd = (PrimaryVolumeDescriptor*) memman_alloc_4k(memman, sizeof(PrimaryVolumeDescriptor));
    IDEDriver_read(driver, 16, pvd, SECTOR_SIZE); /* 16ZN^[܂ł̓u[g̈Ȃ̂ */
    if (pvd->type[0] != ISO_PRIMARY_VOLUME_DESCRIPTOR || strncmp("CD001", pvd->id, 5) != 0) {
        return;
    }

    /* [gfBNgǂݍ */
    DirectoryEntry* root = (DirectoryEntry *)( pvd->root_directory_record );
    dword size = ((dword)((root->size_l + SECTOR_SIZE - 1) / SECTOR_SIZE)) * SECTOR_SIZE;
    byte* buffer = (byte *) memman_alloc_4k(memman, size);
    IDEDriver_read(driver, root->extent_l, buffer, size);
    dword position;
    for (position = 0; position < size;) {
        DirectoryEntry* dir = (DirectoryEntry *) (buffer + position);
        if (dir->size_l == 0) {
            break;
        } else if (dir->directory == 0) {
            if (strncmp(dir->name, cmdline + 8, 12) == 0) {
                byte* data = (byte *) memman_alloc_4k(memman, size);
                IDEDriver_read(driver, dir->extent_l, data, dir->size_l);
				hrb_api_fopen(cmdline + 8, 0, fh, fat);
				hrb_api_fwrite(data, size, fh, fat);
				hrb_api_fclose(fh, fat);
                return;
            }
        }
        position += dir->length;
    }
    memman_free_4k(memman, (int) buffer, size);
	cons_newline(cons);
	return;
}

void cmd_ncst(struct CONSOLE *cons, char *cmdline, int memtotal)
{
	struct TASK *task = open_constask(0, memtotal);
	struct FIFO32 *fifo = &task->fifo;
	int i;
	/* R}hCɓ͂ꂽAꕶVR\[ɓ */
	for (i = 5; cmdline[i] != 0; i++) {
		fifo32_put(fifo, cmdline[i] + 256);
	}
	fifo32_put(fifo, 10 + 256);	/* Enter */
	cons_newline(cons);
	return;
}

void cmd_langmode(struct CONSOLE *cons, char *cmdline)
{
	struct TASK *task = task_now();
	unsigned char mode = cmdline[9] - '0';
	if (mode <= 2) {
		task->langmode = mode;
	} else {
		cons_putstr0(cons, "Invalid langmode number.\n");
	}
	cons_newline(cons);
	return;
}

void cmd_setvar(struct CONSOLE *cons, char *cmdline, int mode)
{
	char *p = &cmdline[4];

	if (mode == VAR_WALL) {
		OS_WALLJPG = p;
	}
	if (mode == VAR_OSNAME) {
	}

	cons_putstr0(cons, "SetVar : [OK]\n");
	cons_newline(cons);
	return;
}

void cmd_isotope(struct CONSOLE *cons)
{
	cons_putstr0(cons, OS_AUTHOR);
	cons_putstr0(cons, " ");
	cons_putstr0(cons, OS_NAMEU);
	cons_putstr0(cons, "\n\t ");
	cons_putstr0(cons, "[version ");
	cons_putstr0(cons, OS_VER);
	cons_putstr0(cons, " ]\n\n");
	return;
}

void cmd_bootdevmode(struct CONSOLE *cons)
{
	cons_putstr0(cons, "BootDevice : \"");
	cons_putstr0(cons, BD_MODE);
	cons_putstr0(cons, "\"");
	cons_putstr0(cons, "\n\n");
	return;
}

void cmd_time(struct CONSOLE *cons)
{
	unsigned char s[24], t[7];
	readrtc(t);
	sprintf(s, "%02X%02X/%02X/%02X %02X:%02X:%02X\n\n", t[6], t[5], t[4], t[3], t[2], t[1], t[0]);
	cons_putstr0(cons, s);
	return;
}

void cmd_reset(struct CONSOLE *cons)
{
	sys_reset();
}

void cmd_shutdown(struct CONSOLE *cons)
{
	sys_shutdown();
}

void cmd_help(struct CONSOLE *cons, int *fat, int memtotal, int mode)
{
	if (mode == 0) {
		cons_runcmd("langmode 1", cons, fat, memtotal);
		cons_runcmd("ncst tview help.txt", cons, fat, memtotal);
	} else if (mode == 1) {
		cons_runcmd("langmode 1", cons, fat, memtotal);
		cons_runcmd("ncst tview cmd.txt", cons, fat, memtotal);
	}
}

int cmd_app(struct CONSOLE *cons, int *fat, char *cmdline)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct FILEINFO *finfo;
	char name[18], *p, *q;
	struct TASK *task = task_now();
	int i, segsiz, datsiz, esp, dathrb, appsiz;
	struct SHTCTL *shtctl;
	struct SHEET *sht;

	/*
	               _____________________
	              [ MOGEX̎st@C ]
	               ~~~~~~~~~~~~~~~~~~~~~
	 ______________________________________________________ 
	|        |                              |              |
	| gq |             l             |  VOl`  |
	|________|______________________________|______________|
	|        |                              |              |
	|  .V    |  OVISCO̖cB |     MOGE     |
	|  .HRB  |  c͂ڂOSst@C  |     Hari     |
	|________|______________________________|______________|

	*/

	/* R}hCt@C𐶐 */
	for (i = 0; i < 13; i++) {
		if (cmdline[i] <= ' ') {
			break;
		}
		name[i] = cmdline[i];
	}
	name[i] = 0; /* Ƃ肠t@Č0ɂ */

	/* t@CT */
	finfo = file_search(name, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);
	if (finfo == 0) {
		/* Ȃ̂Ō".V"ĂxTĂ݂ */
		name[i    ] = '.';
		name[i + 1] = 'V';
		name[i + 2] = 0;
		name[i + 3] = 0;
		name[i + 4] = 0;
		finfo = file_search(name, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);
	}
	if (finfo == 0) {
		/* Ȃ̂Ō".HRB"ĂxTĂ݂ */
		name[i    ] = '.';
		name[i + 1] = 'H';
		name[i + 2] = 'R';
		name[i + 3] = 'B';
		name[i + 4] = 0;
		finfo = file_search(name, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);
	}


	if (finfo != 0) {
		/* t@Cꍇ */
		appsiz = finfo->size;
		p = file_loadfile2(finfo->clustno, &appsiz, fat);
		if (appsiz >= 36 && (strncmp(p + 4, "Hari", 4) == 0 || strncmp(p + 4, "MOGE", 4) == 0) && *p == 0x00) {
			segsiz = *((int *) (p + 0x0000));
			esp    = *((int *) (p + 0x000c));
			datsiz = *((int *) (p + 0x0010));
			dathrb = *((int *) (p + 0x0014));
			q = (char *) memman_alloc_4k(memman, segsiz);
			task->ds_base = (int) q;
			set_segmdesc(task->ldt + 0, appsiz - 1, (int) p, AR_CODE32_ER + 0x60);
			set_segmdesc(task->ldt + 1, segsiz - 1, (int) q, AR_DATA32_RW + 0x60);
			for (i = 0; i < datsiz; i++) {
				q[esp + i] = p[dathrb + i];
			}
			start_app(0x1b, 0 * 8 + 4, esp, 1 * 8 + 4, &(task->tss.esp0));
			shtctl = (struct SHTCTL *) *((int *) 0x0fe4);
			for (i = 0; i < MAX_SHEETS; i++) {
				sht = &(shtctl->sheets0[i]);
				if ((sht->flags & 0x11) == 0x11 && sht->task == task) {
					/* AvJςȂɂ𔭌 */
					sheet_free(sht);	/*  */
				}
			}
			for (i = 0; i < 8; i++) {	/* N[YĂȂt@CN[Y */
				if (task->fhandle[i].buf != 0) {
					memman_free_4k(memman, (int) task->fhandle[i].buf, task->fhandle[i].size);
					task->fhandle[i].buf = 0;
				}
			}
			timer_cancelall(&task->fifo);
			memman_free_4k(memman, (int) q, segsiz);
			task->langbyte1 = 0;
		} else {
			cons_putstr0(cons, "Invalid header.\n");
		}
		memman_free_4k(memman, (int) p, appsiz);
		cons_newline(cons);
		return 1;
	}
	/* t@CȂꍇ */
	return 0;
}

void cmd_notfound(char *cmdline, struct CONSOLE *cons)
{
	cons_putstr0(cons, cmdline);
	cons_putstr0(cons, " is not installed.\n\n");
	return;
}

void dir_cons(struct CONSOLE *cons, struct FILEINFO *finfo)
{
	int i;
	char s[30];
	memset(s, 0, sizeof(s));
	if (finfo->name[0] != 0xe5) {
		if ((finfo->type & 0x18) == 0) {
			sprintf(s, "filename.ext   %7d\n", finfo->size);
			for (i = 0; i < 8; i++) {
				s[i] = finfo->name[i];
			}
			s[ 9] = finfo->ext[0];
			s[10] = finfo->ext[1];
			s[11] = finfo->ext[2];
		} else if ((finfo->type & 0x10) == 0x10) {
			sprintf(s, "dir0name       <DIR>  \n");
			for (i = 0; i < 8; i++) {
				s[i] = finfo->name[i];
			}
		}
		cons_putstr0(cons, s);
	}
	return;
}

int Openfile(struct CONSOLE *cons, char *filename, int *fat)
{
	return 0;
}
