#include "../main/bootpack.h"
#include <stdio.h>
unsigned char rgb2pal(int r, int g, int b, int x, int y);

extern struct SHEET *ActiveSheet;
extern unsigned short table_8_565[256];

void load_screen8(int *fat, unsigned short *vram, int x, int y)
{
	boxfill8(vram, x, COL8_008484, 0, 0, x, y);
	
	return;
}

void init_screen8(int *fat, unsigned short *vram, int x, int y)
{
	/* ǎ̓ǂݍ */
	struct BOOTINFO *binfo = (struct BOOTINFO *) ADR_BOOTINFO;
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	unsigned char *filebuf, r, g, b;
	struct DLL_STRPICENV env;
	struct RGB *picbuf;
	int info[4], fsize, xx, yy;
	struct FILEINFO *finfo = file_search(OS_WALLJPG, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);

	if (binfo->vmode == 16 && finfo != 0) {
		fsize   = finfo->size;
		filebuf = (unsigned char *) memman_alloc_4k(memman, fsize);
		filebuf = file_loadfile2(finfo->clustno, &fsize, fat);
		info_JPEG(&env, info, fsize, filebuf);
		picbuf  = (struct RGB *) memman_alloc_4k(memman, info[2] * info[3] * sizeof(struct RGB));
		decode0_JPEG(&env, fsize, filebuf, 4, (unsigned char *) picbuf, 0);
		for (yy = 0; yy < info[3]; yy++) {
			for (xx = 0; xx < info[2]; xx++) {
				r = picbuf[yy * info[2] + xx].r;
				g = picbuf[yy * info[2] + xx].g;
				b = picbuf[yy * info[2] + xx].b;
				vram[yy * x + xx] = (unsigned short)(((r << 8) & 0xf800) | ((g << 3) & 0x07e0) | (b >> 3));
			}
		}
	} else {
		boxfill8(vram, x, COL8_008484,  0,     0,      x -  1, y - 29);
	}

	//^XNo[
	if (DT_TASKBAR == 1) {
		boxfill8(vram, x, COL8_FFFFFF ,0,y - 30, x, y - 30);
		boxfill8(vram, x, COL8___BASE ,0,y - 29, x,  y - 1);
	}

	return;	
}

void init_mouse_cursor8(short *mouse, char bc)
/* }EXJ[\i16x16j */
{
	static char *cursor[16] = {
		"**..............",
		"*O*.............",
		"*OO*............",
		"*OOO*...........",
		"*OOOO*..........",
		"*OOOOO*.........",
		"*OOOOOO*........",
		"*OOOOOOO*.......",
		"*OOOOOOOO*......",
		"*OOOOO*****.....",
		"*OO*OO*.........",
		"*O*.*OO*........",
		"**..*OO*........",
		"*....*OO*.......",
		".....*OO*.......",
		"......**........"
	};
	int x, y;

	for (y = 0; y < 16; y++) {
		for (x = 0; x < 16; x++) {
			if (cursor[y][x] == '*') {
				mouse[y * 16 + x] = table_8_565[COL8_000000];
			}
			if (cursor[y][x] == 'O') {
				mouse[y * 16 + x] = table_8_565[COL8_FFFFFF];
			}
			if (cursor[y][x] == '.') {
				mouse[y * 16 + x] = table_8_565[bc & 0xff];
			}
		}
	}
	return;
}

void cursor_wait(short *mouse, char bc)
/* }EXJ[\i16x16j */
{
	static char *cursor[16] = {
		"....*********...",
		"....*OOOOOOO*...",
		"....*********...",
		"....*OOOOOOO*...",
		"....*O*O*O*O*...",
		"....*OO*O*OO*...",
		".....*OO*OO*....",
		"......*OOO*.....",
		"......*O*O*.....",
		".....*OO*OO*....",
		"....*OO*O*OO*...",
		"....*O*O*O*O*...",
		"....*OOOOOOO*...",
		"....*********...",
		"....*OOOOOOO*...",
		"....*********..."
	};
	int x, y;

	for (y = 0; y < 16; y++) {
		for (x = 0; x < 16; x++) {
			if (cursor[y][x] == '*') {
				mouse[y * 16 + x] = table_8_565[COL8_000000];
			}
			if (cursor[y][x] == 'O') {
				mouse[y * 16 + x] = table_8_565[COL8_FFFFFF];
			}
			if (cursor[y][x] == '.') {
				mouse[y * 16 + x] = table_8_565[bc & 0xff];
			}
		}
	}
	return;
}

unsigned char rgb2pal(int r, int g, int b, int x, int y)
{
	static int table[4] = { 3, 1, 0, 2 };
	int i;
	x &= 1; /*  */
	y &= 1;
	i = table[x + y * 2];	/* ԐF邽߂̒萔 */
	r = (r * 21) / 256;	/*  0`20 ɂȂ */
	g = (g * 21) / 256;
	b = (b * 21) / 256;
	r = (r + i) / 4;	/*  0`5 ɂȂ */
	g = (g + i) / 4;
	b = (b + i) / 4;
	return 16 + r + g * 6 + b * 36;
}

//X^[g{^p̃{^`悷
void put_button(struct SHEET *sht, int ispush)
{
	short *vram = sht->buf;
	int x = sht->bxsize;
	int y = sht->bysize;

	if (ispush == 0) {
		boxfill8(vram, x, COL8_C6C6C6,   0,     0,   x,     y);
		boxfill8(vram, x, COL8_FFFFFF,   0,     0, x-1,     0);
		boxfill8(vram, x, COL8_FFFFFF,   0,     0,   0,   y-1);
		boxfill8(vram, x, COL8_848484,   1,   y-2, x-2,   y-2);
		boxfill8(vram, x, COL8_848484, x-2,     1, x-2,   y-2);
		boxfill8(vram, x, COL8_000000,   0,   y-1, x-1,   y-1);
		boxfill8(vram, x, COL8_000000, x-1,     0, x-1,   y-1);
	} else {
		boxfill8(vram, x, COL8_C6C6C6,   0,     0,   x,     y);
		boxfill8(vram, x, COL8_000000,   0,     0,   x,     0);
		boxfill8(vram, x, COL8_000000,   0,     0,   0,     y);
		boxfill8(vram, x, COL8_848484,   1,     1, x-1,     1);
		boxfill8(vram, x, COL8_848484,   1,     1,   1,   y-1);
		boxfill8(vram, x, COL8_FFFFFF,   1,   y-1, x-1,   y-1);
		boxfill8(vram, x, COL8_FFFFFF, x-1,     1, x-1,   y-1);
	}
	
	sht->flags |= 0x100;
	sheet_refresh(sht, 0, 0, x, y);
	return;
}

void msgbox(char *str)
{
	extern struct SHTCTL *shtctl;
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct SHEET *sht = sheet_alloc(shtctl);
	unsigned short *buf = (unsigned short *) memman_alloc_4k(memman, 256 * 165);
	sheet_setbuf(sht, buf, 256, 165, -1);
	make_window8(buf, 256, 165, "MGX-Inf", 0);
	sht->task = task_now();
	sht->flags |= 0x05;

	boxfill8(sht->buf, sht->bxsize, COL8_FFFFFF, 8, 27, sht->bxsize - 8, sht->bysize - 8);
	putfonts8_asc(sht->buf, sht->bxsize, 8, 30, COL8_000000, str);

	sheet_slide(sht, 60, 60);
	sheet_updown(sht, shtctl->top);
	return;
}

struct SHEET *init_menu(struct SHTCTL *shtctl, struct TASK *task)
{
	struct BOOTINFO *binfo = (struct BOOTINFO *) ADR_BOOTINFO;
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct SHEET *sht = sheet_alloc(shtctl);
	unsigned short *buf = (unsigned short *) memman_alloc_4k(memman, 200 * 150);

	sheet_setbuf(sht, buf, 200, 150, -1);
	make_menu(buf, 200, 150, "MOGEX-Menu");
	sht->flags |= 0x200;

	putfonts8_asc(sht->buf, 200, 2, 1 * 20 + 3, 17, "Terminal");
	putfonts8_asc(sht->buf, 200, 2, 2 * 20 + 3, 17, "Application            >");
	putfonts8_asc(sht->buf, 200, 2, 3 * 20 + 3, 17, "System                 >");
	putfonts8_asc(sht->buf, 200, 2, 4 * 20 + 3, 17, "Help");
	putfonts8_asc(sht->buf, 200, 2, 5 * 20 + 3, 17, "Shutdown");

	sheet_slide(sht, 0, binfo->scrny-150-30);
	sheet_updown(sht, shtctl->top);

	return sht;
}

void close_menu(struct SHEET *sht)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;

	memman_free_4k(memman, (int) sht->buf, 200 * 300);
	sheet_free(sht);

	return;
}

void make_menu(unsigned short *buf, int xsize, int ysize, char *title)
{

	boxfill8(buf, xsize,         COL8_FFFFFF, 0,         0,	        xsize    , ysize    );
	boxfill8(buf, xsize,         COL8_000000, 1,         1,         xsize - 2, ysize - 2);
	boxfill8(buf, xsize,         COL8_C6C6C6, 2,         2,         xsize - 3, ysize - 3);
	boxfill8(buf, xsize,         COL8_000000, 2,         2,         xsize - 3, 20       );

	putfonts8_asc(buf, xsize,                 3,         3,       COL8_FFFFFF, title);

	return;
}

void os_ver(void)
{
	char *str = 0;

	sprintf(str, "%s [version %s]", OS_NAMEU, OS_VER);
	msgbox(str);
	return;
}
