#include "../main/bootpack.h"
#include <stdio.h>
#include <string.h>

#define	BADNUM	0xffff

// 0-8̔zɂȂĂ̂̓`l0-8܂ł邩
unsigned char tmp_Op40_1[8];	// 40+OP
unsigned char tmp_Op20_0[8];	// 20+OP
unsigned char tmp_Op20_1[8];	// 20+OP
unsigned char tmp_OpB0[8];		// B0+OP

char Op20t[2];
char Op40t[2];
char Op60t[2];
char Op80t[2];
char OpE0t[2];
char OpC0t;

void adlib_patch_sine(void)   { Op20t[0] = 0x00; Op20t[1] = 0x21;
								Op40t[0] = 0x3f; Op40t[1] = 0x00;
								Op60t[0] = 0x00; Op60t[1] = 0xff;
								Op80t[0] = 0x00; Op80t[1] = 0x0f;
								OpE0t[0] = 0x00; OpE0t[1] = 0x00;
								OpC0t    = 0x00; }

void adlib_patch_piano(void)  { Op20t[0] = 0x11; Op20t[1] = 0x21;
								Op40t[0] = 0x90; Op40t[1] = 0x00;
								Op60t[0] = 0x82; Op60t[1] = 0xf2;
								Op80t[0] = 0x02; Op80t[1] = 0x73;
								OpE0t[0] = 0x00; OpE0t[1] = 0x00;
								OpC0t    = 0x0a; }

void adlib_patch_guitar(void) { Op20t[0] = 0x10; Op20t[1] = 0x21;
								Op40t[0] = 0xff; Op40t[1] = 0x00;
								Op60t[0] = 0x82; Op60t[1] = 0xff;
								Op80t[0] = 0x02; Op80t[1] = 0x73;
								OpE0t[0] = 0x00; OpE0t[1] = 0x00;
								OpC0t    = 0x0a; }

void io_out16(int port, int data);
void io_out8(int port, int data);
int io_in8(int port);

void adlib389w(char value);
void adlib388w(char value);
void adlibw(int regist, char value);

void beep(int hz)
{
	int i;
	if (hz == 0) {
		i = io_in8(0x61);
		io_out8(0x61, i & 0x0d);
	} else {
		i = 1193180000 / hz;
		io_out8(0x43, 0xb6);
		io_out8(0x42, i & 0xff);
		io_out8(0x42, i >> 8);
		i = io_in8(0x61);
		io_out8(0x61, (i | 0x03) & 0x0f);
	}
	return;
}

////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////

/* Adlib(FM)݂邩mFB (http://wiki.osdev.info/?AdLib) */
int found_adlib(void)
{
	int i;
	char data1, data2;

	adlibw(0x04, 0x60);
	adlibw(0x04, 0x80);
	data1 = io_in8(0x388);

	adlibw(0x02, 0xff);
	adlibw(0x04, 0x21);

	/* 80}CNbȏ҂āAƂƂȂ̂Ń|[gǂ݂ĉɂԂB */
	for (i = 0; i < 125; i++)
		io_in8(0x388);

	data2 = io_in8(0x388);

	adlibw(0x04, 0x60);
	adlibw(0x04, 0x80);

	return ((data1 & 0xe0) == 0x00) && ((data2 & 0xe0) == 0xc0);
}

/* 0x388ɃANZXWX^̔ԍāA0x389ɏށB */
void adlibw(int regist, char value)
{
	adlib388w(regist);
	adlib389w(value);
	return;
}

// AdlibWX^|[g : 0x388
void adlib388w(char value)
{
	int i;
	io_out8(0x388, value);
	for (i = 0; i < 6; i++)
		io_in8(0x388);
	return;
}

// Adlibf[^|[g : 0x389
void adlib389w(char value)
{
	int i;
	io_out8(0x389, value);
	for (i = 0; i < 25; i++)
		io_in8(0x388);
	return;
}

// Iy[^ݒ
void adlibOPw(int base, int ch, int op, char value)
{
	int reg = base + ch;

	if (ch > 2)	reg += 5;
	if (ch > 5)	reg += 5;
	if (op)		reg += 3;

	adlibw(reg, value);

	return;
}

// `lݒ
void adlibCHw(int base, int ch, char value)
{
	int reg = base + ch;

	adlibw(reg, value);
	return;
}

unsigned int adlibBfreq(int freq)
{
	unsigned long f_num = 2 * 524288 * freq / 50000;
	unsigned int  block = 0;

	while ((f_num > 0x3ff) && (block < 0x08))
	{
		block++;
		f_num = f_num / 2;
	}

	if (block > 7)
		return BADNUM;									// sBBADNUMԂB
	else
		return (block << 10) | (unsigned int) f_num;	// I
}

// Đ
int adlib_play(int ch, int freq, int vol)
{
	unsigned int block_fnum;
	int	mult = 1, c_mult, m_mult;
    unsigned char Op20_1, Op20_2, Op40, OpA0, OpB0;		// OP

	do {
		block_fnum = adlibBfreq(freq / mult);

		// adlibBfreq() ̖߂l BADNUM multVB
		if (block_fnum == BADNUM)
		{
			mult = mult * 2;

			// mult = 16  15 ɂĔB
			if (mult == 16) {
				mult = 15;
				break;
			}
		}
	} while (block_fnum == BADNUM);

	m_mult = (tmp_Op20_0[ch] & 0x0f) * mult;
	c_mult = (tmp_Op20_1[ch] & 0x0f) * mult;

	if ((block_fnum == BADNUM) || (m_mult > 15) || (c_mult > 15)) return 0;

	Op20_1 = (tmp_Op40_1[ch] & 0xf0) | m_mult;
	Op20_2 = (tmp_Op20_1[ch] & 0xf0) | c_mult;
	Op40   = (tmp_Op40_1[ch] & 0xc0) | (63 - vol);		// {[́u63vőŁAΏقǉ傫Ȃ̂63ňĂB

	block_fnum |= 0x2000;								// KeyONԂɂB

	OpA0  = block_fnum &  0xff;
	OpB0  = block_fnum >> 0x08;

	tmp_OpB0[ch] = OpB0;

	adlibOPw(0x20, ch, 0, Op20_1);
	adlibOPw(0x20, ch, 1, Op20_2);
	adlibOPw(0x40, ch, 1, Op40);
	adlibCHw(0xa0, ch,    OpA0);
	adlibCHw(0xb0, ch,    OpB0);

	return 1;
}

// ~
void adlib_stop(int ch)
{
	adlibCHw(0xb0, ch, tmp_OpB0[ch] & 0xdf);
	return;
}

// ̃[h
void adlib_load_patch(int ch)
{
	adlibOPw(0x20, ch, 0, Op20t[0]);
	adlibOPw(0x20, ch, 1, Op20t[1]);
	adlibOPw(0x40, ch, 0, Op40t[0]);
	adlibOPw(0x40, ch, 1, Op40t[1]);
	adlibOPw(0x60, ch, 0, Op60t[0]);
	adlibOPw(0x60, ch, 1, Op60t[1]);
	adlibOPw(0x80, ch, 0, Op80t[0]);
	adlibOPw(0x80, ch, 1, Op80t[1]);
	adlibOPw(0xe0, ch, 0, OpE0t[0]);
	adlibOPw(0xe0, ch, 1, OpE0t[1]);
	adlibCHw(0xc0, ch,    OpC0t);

	tmp_Op40_1[ch] = Op40t[1];
	tmp_Op20_0[ch] = Op20t[0];
	tmp_Op20_1[ch] = Op20t[1];
	return;
}
