#include "../main/bootpack.h"

void io_out16(int port, int data);

void set_qemuvga0reg(int reg, int dat)
{
	io_out16(0x01ce, reg);
	io_out16(0x01cf, dat);
	return;
}

void init_qemuvga0(struct BOOTINFO *binfo, int x, int y, int c, int flag)
{
	set_qemuvga0reg(0x0004, 0x0000);
	set_qemuvga0reg(0x0001, x);
	set_qemuvga0reg(0x0002, y);
	set_qemuvga0reg(0x0003, c);		/* 4, 8, 15, 16, 24, 32 */
	set_qemuvga0reg(0x0005, 0x0000);
	set_qemuvga0reg(0x0004, flag);	/* jAANZX[hVRAM̏Ȃ0x41 */
		/* bit7 : VRAM}, bit6 : jAANZX[h, bit0 : ݒL */
	binfo->scrnx = x;
	binfo->scrny = y;
	binfo->vmode = c;
	if ((flag & 0x40) == 0) {
		binfo->vram = (char *) 0x000a0000;
	} else {
		binfo->vram = (char *) 0xe0000000;
	}
	return;
}

