/* EBhE֌W */

#include "../main/bootpack.h"

extern unsigned short table_8_565[256];

void putfonts8_asc_sht(struct SHEET *sht, int x, int y, int c, int b, char *s, int l)
{
	struct TASK *task = task_now();
	boxfill8(sht->buf, sht->bxsize, b, x, y, x + l * 8 - 1, y + 15);
	if (task->langmode != 0 && task->langbyte1 != 0) {
		putfonts8_asc(sht->buf, sht->bxsize, x, y, c, s);
		sheet_refresh(sht, x - 8, y, x + l * 8, y + 16);
	} else {
		putfonts8_asc(sht->buf, sht->bxsize, x, y, c, s);
		sheet_refresh(sht, x, y, x + l * 8, y + 16);
	}
	return;
}

void make_textbox8(struct SHEET *sht, int x0, int y0, int sx, int sy, int c)
{
	int x1 = x0 + sx, y1 = y0 + sy;
	boxfill8(sht->buf, sht->bxsize, COL8_848484, x0 - 2, y0 - 3, x1 + 1, y0 - 3);
	boxfill8(sht->buf, sht->bxsize, COL8_848484, x0 - 3, y0 - 3, x0 - 3, y1 + 1);
	boxfill8(sht->buf, sht->bxsize, COL8_FFFFFF, x0 - 3, y1 + 2, x1 + 1, y1 + 2);
	boxfill8(sht->buf, sht->bxsize, COL8_FFFFFF, x1 + 2, y0 - 3, x1 + 2, y1 + 2);
	boxfill8(sht->buf, sht->bxsize, COL8_000000, x0 - 1, y0 - 2, x1 + 0, y0 - 2);
	boxfill8(sht->buf, sht->bxsize, COL8_000000, x0 - 2, y0 - 2, x0 - 2, y1 + 0);
	boxfill8(sht->buf, sht->bxsize, COL8_C6C6C6, x0 - 2, y1 + 1, x1 + 0, y1 + 1);
	boxfill8(sht->buf, sht->bxsize, COL8_C6C6C6, x1 + 1, y0 - 2, x1 + 1, y1 + 1);
	boxfill8(sht->buf, sht->bxsize, c,           x0 - 1, y0 - 1, x1 + 0, y1 + 0);
	return;
}

void make_window8(unsigned short *buf, int xsize, int ysize, char *title, char act)
{
	boxfill8(buf, xsize,         COL8_000000, 0,         0,	        xsize    , ysize    );
	boxfill8(buf, xsize,         COL8_FFFFFF, 1,         1,         xsize - 2, ysize - 2);
	boxfill8(buf, xsize,		 COL8___BASE, 2,         2,         xsize - 2, ysize - 2);
	boxfill8(buf, xsize,         COL8_FFFFFF, 8,        29,         xsize - 9, ysize - 9);
	boxfill8(buf, xsize,         COL8_SHADOW, xsize - 2, 2,         xsize - 2, ysize - 2);
	boxfill8(buf, xsize,         COL8_SHADOW, 2, ysize - 2,         xsize - 2, ysize - 2);

	make_wtitle8(buf, xsize, title, act);
	return;
}

void make_wtitle8(unsigned short *buf, int xsize, char *title, char act)
{
	static char *closebtn[16] = {
		" ############## ",
		"#OOOOOOOOOOOOOO#",
		"#OOOOOOOOOOOOOO#",
		"#OOOOOOOOOOOOOO#",
		"#OOO@@OOOO@@OOO#",
		"#OOOO@@OO@@OOOO#",
		"#OOOOO@@@@OOOOO#",
		"#OOOOOO@@OOOOOO#",
		"#OOOOO@@@@OOOOO#",
		"#OOOO@@OO@@OOOO#",
		"#OOO@@OOOO@@OOO#",
		"#OOOOOOOOOOOOOO#",
		"#OOOOOOOOOOOOOO#",
		"#OOOOOOOOOOOOOO#",
		" ############## ",
		"                "
	};
	int x, y;
	char c, tc, tbc;
	if (act != 0) {
		tc = COL8_FFFFFF;
		tbc = COL8___BASE;
	} else {
		tc = COL8_848484;
		tbc = COL8___BASE;
	}

	boxfill8(buf, xsize, tbc, 3, 3, xsize - 4, 20);
	putfonts8_asc(buf, xsize, 24, 4, tc, title);
	for (y = 0; y < 16; y++) {
		for (x = 0; x < 16; x++) {
			c = closebtn[y][x];
			if (c == '@') {
				c = COL8_848484;
			} else if ( c == '|' || c == 'O') {
				c = COL8_C6C6C6;
			} else if (c == ' ') {
				c = tbc;
			} else if (c == '#') {
				c = COL8_848484;
			}
			buf[(5 + y) * xsize + (xsize - 21 + x)] = table_8_565[c & 0xff];
		}
	}
	return;
}

void change_wtitle8(struct SHEET *sht, char act)
{
	int x, y, xsize = sht->bxsize;
	unsigned char tc_new, tbc_new, tc_old, tbc_old;
	unsigned short c565, *buf = sht->buf;
	if (act != 0) {
		tc_new  = COL8_FFFFFF;
		tbc_new = COL8___BASE;
		tc_old  = COL8_848484;
		tbc_old = COL8___BASE;
	} else {
		tc_new  = COL8_848484;
		tbc_new = COL8___BASE;
		tc_old  = COL8_FFFFFF;
		tbc_old = COL8___BASE;
	}
	for (y = 3; y <= 20; y++) {
		for (x = 3; x <= xsize - 4; x++) {
			c565 = buf[y * xsize + x];
			if (c565 == table_8_565[tc_old] && x <= xsize - 22) {
				c565 = table_8_565[tc_new];
			} else if (c565 == table_8_565[tbc_old]) {
				c565 = table_8_565[tbc_new];
			}
			buf[y * xsize + x] = c565;
		}
	}
	sheet_refresh(sht, 3, 3, xsize, 21);
	return;
}
